﻿#include <iostream>
#include <algorithm>
#include <string>
#include <tuple>
#include <set>
#include <array>
#include <cmath>
#include <map>
#include <vector>
#include <complex>
#include <list>
#include <optional>
#include <unordered_map>

std::vector<std::vector<bool>> can;

std::optional<std::vector<long long>> find(int n, int k, int max)
{

	if (n < 0)
		return std::nullopt;
	if (k == 0 && n == 0)
		return std::vector<long long>();
	if (k == 0 && n != 0)
		return std::nullopt;
	if (can[n][k] == false)
		return std::nullopt;
	for (int i = max; i > 0; --i)
	{
		auto f = find(n - i * i, k - 1, i - 1);
		if (f.has_value())
		{
			f.value().push_back(i);
			return f;
		}
	}
	can[n][k] = false;
	return std::nullopt;
}

void solve()
{
	int n, k;

	std::cin >> n >> k;

	if (n > 120000 && k==20)
	{
		std::cout << "NO";
		exit(0);
	}
	can.resize(n * (k - 1) + 1, std::vector<bool>(k + 1, true));
	auto f = find(n * (k - 1), k, std::ceil(sqrt(n)) - 1);
	if (f.has_value())
	{
		std::cout << "YES" << std::endl;
		for (auto c : f.value())
		{
			std::cout << n - c * c << " ";
		}
	}
	else
	{
		std::cout << "NO";
	}
}

int main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);



	int t = 1;
	//std::cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}
