import java.lang.Integer.max

class Variants(val number: Int) {
    val dividers = mutableSetOf<Int>(1)
    val extraDividers = mutableSetOf<Int>(1)
    val otherPrimes = mutableListOf<Int>(1)
    fun registerPrime(prime: Int) {
        if (number % prime == 0) {
            dividers.add(prime)
        } else {
            otherPrimes.add(prime)
        }
    }

    fun tryAddDivider(i: Int) {
        if (number % i == 0) {
            val sqrt = Math.sqrt(i.toDouble()).toInt()
            if (sqrt * sqrt == i && number % sqrt != 0) {
                dividers.add(i)
            } else {
                extraDividers.add(i)
            }
        }
    }
}

fun main() {
    val x = readLine()?.toIntOrNull()!!//x
    val l = readLine()?.toIntOrNull()!!//l
    val r = readLine()?.toIntOrNull()!!//r

    val variantR = Variants(r)
    val variantX = Variants(x)
    val primes = mutableListOf<Int>()
    for (i in 2 until max(r, x)) {
        if (i != 2 && i and 0b1 == 0) {
            variantX.tryAddDivider(i)
            continue
        }
        var isPrime = true;
        for (prime in primes) {
            if (i % prime == 0) {
                isPrime = false;
                break
            }
        }
        if (!isPrime) {
            variantX.tryAddDivider(i)
            continue
        }
        primes.add(i)
//        variantR.registerPrime(i)
        variantX.registerPrime(i)
    }
    val resultList = mutableListOf<Int>()
    for (divider in variantX.dividers) {
        var multiplier = 1;
        while (divider * multiplier < r) {
            val currDiv = divider * multiplier
            if (multiplier == 1 || currDiv !in variantX.dividers && currDiv !in variantX.extraDividers) {
                for (prime in variantX.otherPrimes) {
                    val element = prime * currDiv
                    if (element < l) continue
                    if (element > r) break
                    resultList.add(element)
                }
            }
            multiplier *= divider;
//            if (true)break
            if (divider == 1) break
        }
    }
    println(resultList.size)
    resultList.sort()
    println(resultList.joinToString(" "))

}