import java.lang.Integer.max

class Variants(val number: Int) {
    val dividers = mutableSetOf<Int>(1)
    val extraDividers = mutableSetOf<Int>(1)
    val otherPrimes = mutableListOf<Int>(1)
    fun registerPrime(prime: Int) {
        if (number % prime == 0) {
            dividers.add(prime)
        } else {
            otherPrimes.add(prime)
        }
    }

    fun tryAddDivider(i: Int) {
        if (number % i == 0) {
            dividers.add(i)
        }
    }
}

fun main() {
    val x = readLine()?.toIntOrNull()!!//x
    val l = readLine()?.toIntOrNull()!!//l
    val r = readLine()?.toIntOrNull()!!//r

    val variantR = Variants(r)
    val variantX = Variants(x)
    val primes = mutableListOf<Int>()
    for (i in 2 until max(r, x)) {
        if (i != 2 && i and 0b1 == 0) {
            variantX.tryAddDivider(i)
            continue
        }
        var isPrime = true;
        for (prime in primes) {
            if (i % prime == 0) {
                isPrime = false;
                break
            }
        }
        if (!isPrime) {
            variantX.tryAddDivider(i)
            continue
        }
        primes.add(i)
        variantX.registerPrime(i)
    }
    val resultList = mutableListOf<Int>()
    for(number in l..r){
        var divAmount=0;
        for (divider in variantX.dividers) {
            if (divider!=1 &&  number%divider==0) {
                divAmount++;
                if (divAmount>=2)break;
            }
        }
        if (divAmount>1)continue
        resultList.add(number)
    }
    println(resultList.size)
    resultList.sort()
    println(resultList.joinToString(" "))

}