import typing



def task(
    cell_size: int,
    cells_in_row: int,
    cells_in_column: int,
    space_size: int
) -> typing.List[str]:
    resmap = []
    map_width = cells_in_row*cell_size + space_size*(cells_in_row + 1)
    space_fill = "*" * space_size
    empty_fill = "*"*map_width
    for _ in range(space_size):
        resmap.append(empty_fill)

    for _ in range(cells_in_column):
        for _ in range(cell_size):
            resmap.append(
                space_fill + space_fill.join(["."*cell_size]*cells_in_row) + space_fill
            )
        for _ in range(space_size):
            resmap.append(empty_fill)

    return resmap

def main():
    k = int(input())
    w = int(input())
    h = int(input())
    t = int(input())
    result = task(k, w, h, t)
    print(*result, sep="\n")


main()