#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cassert>
#include <type_traits>
#include <unordered_set>

#define debug(x) cerr << (#x) << ":\t" << (x) << endl;

#define fi first
#define se second

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

typedef long long ll;
typedef unsigned long long ull;

int solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();

    return 0;
}

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

bool is_prime(int a) {
    for (int i = 2; i * i <= a; i++) {
        if (a % i == 0) {
            return false;
        }
    }
    return true;
}

int solve() {
    int x, l, r;
    cin >> x >> l >> r;
    vector<int> ans;
    for (int i = l; i <= r; i++) {
        if (i != x) {
            int g = gcd(i, x);
            if (is_prime(g)) {
                ans.push_back(i);
            }
        }
    }
    cout << ans.size() << endl;
    for (int i : ans) {
        cout << i << ' ';
    }
    return 0;
}
