#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cassert>
#include <type_traits>
#include <unordered_set>

#define debug(x) cerr << (#x) << ":\t" << (x) << endl;

#define fi first
#define se second

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

typedef long long ll;
typedef unsigned long long ull;

int solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();

    return 0;
}

int solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a;
    for (int i = 1; i * i < n; i++) {
        a.push_back(n - i * i);
    }
    vector<vector<int>> dp(n + 1, vector<int> (k + 1, -1));
    dp[0][0] = 0;
    for (auto c : a) {
        for (int i = c; i <= n; i++) {
            for (int j = 1; j <= k; j++) {
                if (c <= i && dp[i - c][j - 1] != -1
                    && dp[i][j] == -1 && dp[i - c][j - 1] != c) {
                    dp[i][j] = c;
                }
            }
        }
    }
    if (dp[n][k] == -1) {
        cout << "NO";
        return 0;
    }
    cout << "YES" << endl;
    int i = n, k1 = k;
    while (k1 != 0) {
        cout << dp[i][k1] << ' ';
        k1--;
        i -= dp[i][k1 + 1];
    }
    return 0;
}
