#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void PrintSeq( int *seq, int size )
{
  int i;
  
  for (i = 0; seq[i] != 0 && i < size; i++)
    printf("%i%s", seq[i], i == size - 1 || seq[i + 1] == 0 ? "" : "+");

  printf("\n");
}

int GetSeqSum( int *seq, int size )
{
  int i, sum = 0;
  
  for (i = 0; seq[i] != 0 && i < size; i++)
    sum += seq[i];

  return sum;
}

void MakeSeq( int *seq, int iter, int max )
{
  int i;

  for (i = 1 + (iter > 1 ? seq[iter - 2] : 0); i <= max; i++)
  {
    seq[iter - 1] = i;

    if (iter >= 3)
    {
      if ((float)seq[iter - 2] != (seq[iter - 3] + seq[iter - 1]) / 2.0)
        if (GetSeqSum(seq, iter) <= max)
          if (GetSeqSum(seq, iter) == max)
            PrintSeq(seq, iter);
          else
            MakeSeq(seq, iter + 1, max);
    }
    else
      if (GetSeqSum(seq, iter) <= max)
        if (GetSeqSum(seq, iter) == max)
          PrintSeq(seq, iter);
        else
          MakeSeq(seq, iter + 1, max);
    seq[iter - 1] = 0;
  }
}

int main( void )
{
  int n, MxSqLng, i, sum, *seq;

  scanf("%d", &n);
  
  for (sum = 0, i = 1; sum < n; i++)
    sum += i;

  MxSqLng = i + 1;

  seq = malloc(sizeof(int) * MxSqLng);
  memset(seq, 0, sizeof(seq));

  MakeSeq(seq, 1, n);
  
  getchar();
  getchar();

  return 0;
}