/* Borodulin Fedor 10-1 PML 30 */

#define _CRT_SECURE_NO_WARNINGS

/* Math includes */
#include <cmath>
#include <xmmintrin.h>
#include <immintrin.h>

/* I/O includes */
#include <cstdio>

/* Built-in data structures includes */
#include <vector>
#include <map>
#include <deque>
#include <string>
#include <set>

/* Other includes */
#include <algorithm>
#include <functional>

/* Basic data types definitions */
using int64 = long long;
using uint64 = unsigned long long;
using flt = float;
using dbl = double;
using int_set = std::set<int64>;

/* Task C entry point */
void TaskC( void )
{
  const auto GetDivisors {[]( int64 Val ) -> int_set
  {
    int_set Set {};
    int64 i;

    for (i = 2; i * i < Val; i++)
      if (Val % i == 0)
        Set.emplace(i), Set.emplace(Val / i);

    if (i * i == Val)
      Set.emplace(i);

    Set.emplace(Val);

    return Set;
  }};

  /* true if <= 1, otherwise - false */
  const auto CheckSameCnt {[]( const int_set &Set1, const int_set &Set2 ) -> bool
  {
    int64 Cnt {};
    auto
      Iter1 {Set1.begin()},
      Iter2 {Set2.begin()};

    while (true)
    {
      while (Iter1 != Set1.end() &&
             *Iter1 < *Iter2)
        Iter1++;

      while (Iter2 != Set2.end() &&
             *Iter2 < *Iter1)
        Iter2++;

      if (Iter1 == Set1.end() ||
          Iter2 == Set2.end())
        break;

      if (*Iter1 == *Iter2)
        Cnt++, Iter1++;
    }

    return Cnt <= 1;
  }};

  int64 X, L, R;

  scanf("%lli %lli %lli", &X, &L, &R);

  int_set XDivisors {std::move(GetDivisors(X))};

  std::vector<int64> Res {};

  for (int64 i {L}; i <= R; i++)
    if (i != X && CheckSameCnt(XDivisors, GetDivisors(i)))
      Res.emplace_back(i);

  printf("%llu\n", Res.size());

  for (int64 i {0}; (i + 1) < Res.size(); i++)
    printf("%lli ", Res[i]);

  if (!Res.empty())
    printf("%lli\n", Res.back());
} /* End of 'TaskC' function */

/* Programm entry point */
int main( void )
{
  TaskC();

  return 0;
} /* End of 'main' function */

/* END OF 'main.cpp' FILE */
