#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

typedef uint64_t ull;
typedef vector<ull> uv;

ull gcd(ull a, ull b)
{
	while (a != 0 && b != 0)
	{
		if (b > a)
			b = b - a;
		else
			a = a - b;
	}
	return a + b;
}

bool IsSame(ull x, ull y)
{
	if (x == y)
		return false;
	if (gcd(x, y) == 1)
		return true;
	auto ma = x > y ? x : y;
	auto mi = x < y ? x : y;

	bool was = false;
	ull NumWas = 0;
	ull sma = (ull)ceil(sqrt(ma)) + 1;
	for (ull i = 2; i <= sma; i++)
	{
		if (x % i == 0 && y % i == 0)
		{
			if (was && NumWas != i)
				return false;
			was = true, NumWas = i;
		}
	}
	if (x % mi == 0 && y % mi == 0)
	{
		if (was && NumWas != mi)
			return false;
	}
	return true;
}

int main(void)
{
	ull x, l, r;

	cin >> x >> l >> r;

	if (l == r)
	{
		if (IsSame(x, l))
			cout << 1 << endl << l;
		else
			cout << 0;
		return 0;
	}

	uv All;
	for (ull i = l; i <= r; i++)
		if (IsSame(i, x))
			All.push_back(i);
	cout << All.size() << endl;
	for (ull i = 0; i < (ull)All.size() - 1; i++)
		cout << All[(const unsigned int)i] << " ";
	cout << All[All.size() - 1];
}