#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <tuple>
#include <algorithm>

using namespace std;

typedef uint64_t ull;
typedef vector<ull> uv;
typedef vector<uv> uvv;
typedef pair<ull, ull> up;

#define e0(t) get<0>(t)
#define e1(t) get<1>(t)
#define e2(t) get<2>(t)
#define e3(t) get<3>(t)
#define mt(a, b, c) make_tuple()

vector<up> GetRazb(int n)
{
	vector<up> Res;
	int border = n / 2;
	if (n % 2 != 0)
		border++;

	for (int i = 1; i < border; i++)
		Res.push_back({ i, n - i });
	return Res;
}

vector<tuple<ull, ull, ull>> GetRazb3(int n)
{
	vector<tuple<ull, ull, ull>> Res;

	auto r2 = GetRazb(n);

	for (auto& x : r2)
	{
		cout << x.first << "+" << x.second << endl;
		if (x.first > 2)
		{
			for (auto& rf : GetRazb(x.first))
				Res.push_back({ rf.first, rf.second, x.second });
		}
		if (x.second > 2)
		{
			for (auto& rf : GetRazb(x.second))
			{
				ull Mas[3] = { x.first, rf.first, rf.second };

				sort(&Mas[0], &Mas[2]);
				Res.push_back({ Mas[0], Mas[1], Mas[2] });
			}
		}
	}

	decltype(Res) NewRes;
	for (auto& t : Res)
	{
		auto el1 = e0(t);
		auto el2 = e1(t);
		auto el3 = e2(t);

		if (el1 < el2 && el2 < el3 && 2 * el2 != el1 + el3)
			if (find(NewRes.begin(), NewRes.end(), t) == NewRes.end())
				NewRes.push_back(t);
	}
	return NewRes;
}

void GetRazb4(const vector<up> R2, int n)
{
	vector<tuple<ull, ull, ull, ull>> Res;

	for (auto& x : R2)
	{
		for (auto &rf : GetRazb(x.first))
			for (auto& rs : GetRazb(x.second))
			{
				ull Mas[4] = { rf.first, rf.second, rs.first, rs.second };

				sort(&Mas[0], &Mas[3]);
				Res.push_back({ Mas[0], Mas[1], Mas[2], Mas[3] });
			}
	}
	decltype(Res) NewRes;

	for (auto& t : Res)
	{
		auto el1 = e0(t);
		auto el2 = e1(t);
		auto el3 = e2(t);
		auto el4 = e3(t);

		if (el1 < el2 && el2 < el3 && el3 < el4 && 2 * el2 != el1 + el3 && 2 * el3 != el2 + el4)
			if (find(NewRes.begin(), NewRes.end(), t) == NewRes.end())
				cout << el1 << "+" << el2 << "+" << el3 << "+" << el4 << endl, NewRes.push_back(t);
	}
}

int main(void)
{
	int n;

	cin >> n;

	//if (n == 7)
	//	cout << "1+2+4\n";
	//if (n == 8)
	//	cout << "1+2+5\n1+3+4\n";
	//if (n == 9)
	//	cout << "1+2+6" << endl;
	//if (n == 10)
	//	cout << "1+2+7\n2+3+5\n1+3+6\n1+4+5\n";

	for (auto& p : GetRazb3(n))
		cout << e0(p) << "+" << e1(p) << "+" << e2(p) << endl;
	GetRazb4(GetRazb(n), n);
	cout << n;
}