#include <iostream>
#include <cmath>
#include <numeric>
#include <set>
#include <vector>

using namespace std;
using ll = long long;

bool check(const vector<int> &facts, int a, int b)
{
    int cnt{0};
    
    for (const auto &f : facts)
    {
        if ((a % f == 0) && (b % f == 0))
        {
            a /= f;
            b /= f;
            
            cnt++;
        }

        //cout << cnt << ' ' << a << ' ' << b << '\n';
        if (cnt == 2)
            return false;
    }
    
    return true;
}

vector<int> factorize(int n) {
   vector<int> res;
    
   while (n % 2 == 0){
      res.push_back(2);
      n /= 2;
   }
   for (int i = 3; i <= sqrt(n); i = i+2){
      while (n%i == 0){
        res.push_back(i);
         n /= i;
      }
   }
   
   return res;
}

vector<int> solve(int x, int l, int r)
{
    vector<int> res;
    auto facts{factorize(x)};

    for (int i{l}; i <= r; ++i)
    {
        if (check(facts, x, i))
            res.push_back(i);
    }

    return res;
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;

    auto res{solve(x, l, r)};
    cout << res.size() << '\n';
    for (const auto &r: res)
        cout << r << ' ';
    cout << '\n';
}