#include <iostream>
#include <cmath>
#include <numeric>
#include <set>
#include <vector>

using namespace std;
using ll = long long;

int commDiv(int a, int b)
{
    // find gcd of a, b
    int n = gcd(a, b);
  
    // Count divisors of n.
    int result = 0;
    for (int i = 1; i <= sqrt(n); i++) {
        // if 'i' is factor of n
        if (n % i == 0) {
            // check if divisors are equal
            if (n / i == i)
                result += 1;
            else
                result += 2;
        }
    }
    return result;
}

bool check(const vector<int> &facts, int a, int b)
{
    /*
    int cnt{0};
    
    cnt += (b % a == 0);
    
    for (const auto &f : facts)
    {
        if ((a % f == 0) && (b % f == 0))
        {
            a /= f;
            b /= f;
            
            cnt++;
        }

        if (cnt == 2)
            return false;
    }
    */
    
    return commDiv(a, b) - 1 < 2;
}

vector<int> bad_factorize(int n) {
   vector<int> res;
    
   while (n % 2 == 0){
      res.push_back(2);
      n /= 2;
   }
   for (int i = 3; i <= sqrt(n); i = i+2){
      while (n%i == 0){
        res.push_back(i);
         n /= i;
      }
   }
   
   return res;
}

vector<int> factorize(int n) {
    vector<int> res;
    
    int square_root = (int) sqrt(n) + 1;
    for (int i = 2; i < n; i++) { 
        if (n % i == 0)
            res.push_back(i);
    }
    
    return res;
}


vector<int> solve(int x, int l, int r)
{
    vector<int> res;
    //auto facts{factorize(x)};
    vector<int> facts;

    for (int i{l}; i <= r; ++i)
    {
        if (check(facts, x, i))
            res.push_back(i);
    }

    return res;
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;

    auto res{solve(x, l, r)};
    cout << res.size() << '\n';
    for (const auto &r: res)
        cout << r << ' ';
    cout << '\n';
}