#include <iostream>
#include <cmath>
#include <numeric>
#include <set>
#include <vector>

using namespace std;
using ll = long long;

int commDiv(int a, int b)
{
    // find gcd of a, b
    int n = gcd(a, b);
  
    // Count divisors of n.
    int result = 0;
    for (int i = 1; i <= sqrt(n); i++) {
        // if 'i' is factor of n
        if (n % i == 0) {
            // check if divisors are equal
            if (n / i == i)
                result += 1;
            else
                result += 2;
            n /= i;
        }
    }
    
    return result;
}

bool check(int a, int b)
{
    return commDiv(a, b) < 3;
}


vector<int> solve(int x, int l, int r)
{
    vector<int> res;

    for (int i{l}; i <= r; ++i)
        if (check(x, i))
            res.push_back(i);

    return res;
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;

    auto res{solve(x, l, r)};
    cout << res.size() << '\n';
    for (const auto &r: res)
        cout << r << ' ';
    cout << '\n';
}