#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#endif
#include <bits/stdc++.h>
using namespace std;
#define sz(a) (int)((a).size())

template <class T, class V> ostream & operator << (ostream & os, pair<T, V> const& p) { return os << "{" << p.first << "," << p.second << "}"; }
// template <class T, class V, class Container> basic_ostream <T, V> & operator << (basic_ostream <T, V> & os, Container const& x) { os << "[ "; for (auto& y : x) os << y << " "; return os << "]"; }
template <typename T> bool chmin(T &a, T b) { return (b < a) ? a = b, 1 : 0; }
template <typename T> bool chmax(T &a, T b) { return (b > a) ? a = b, 1 : 0; }

#ifdef LOCAL
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) { cerr << " " << H; deb_out(T...); }
#define deb(...) cerr << "(" << #__VA_ARGS__ << "):", deb_out(__VA_ARGS__)
#else
#define deb(...) 1
#endif

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
#define int long long
const int N = 2e5 + 5;
void solve_test() {
    int n, k;
    cin >> n >> k;
    set<int> sqr;
    auto is_sqr = [&](int x) -> bool {
        ll s = sqrt(x);
        return s * s == x;
    };
    for (int i = 1; i < n; ++i) {
        if (is_sqr(i)) {
            sqr.insert(i);
        }
    }
    vector<int> a;
    for (auto sq : sqr) {
        a.push_back(n - sq);
    }
    sort(a.begin(), a.end());
    if (k == 3) {
        set<int> st;
        for (int x : a)
            st.insert(x);
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                ll rem = n - a[i] - a[j];
                if (rem != a[i] && rem != a[j] && st.find(rem) != st.end()) {
                    cout << "YES\n";
                    cout << rem << " " << a[i] << " " << a[j] << '\n';
                    return;
                }
            }
        }
        cout << "NO\n";
        return;
    }
    vector<vector<bitset<N>>> p(k + 1, vector<bitset<N>>(sz(a)));
    for (int i = 0; i < sz(a); ++i) {
        p[1][i].set(a[i], 1);
    }
    for (int i = 0; i < sz(a); ++i) {
        for (int len = k; len >= 2; --len) {
            for (int j = 0; j < i; ++j) {
                p[len][i] |= p[len - 1][j] << a[i];
            }
        }
    }
    bool ok = false;
    for (int i = 0; i < sz(a); ++i) {
        if (p[k][i][n])
            ok = true;
    }
    if (!ok) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    vector<int> res;
    int need = n;
    int st = sz(a) - 1;
    for (int len = k; len >= 0; --len) {
        for (int i = st; i >= 0; --i) {
            if (p[len][i][need]) {
                res.push_back(a[i]);
                st = i - 1;
                need -= a[i];
            }
        }
    }
    sort(res.begin(), res.end());
    for (int x : res)
        cout << x << ' ';
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    for (int i = 1; i <= tt; ++i) {
        solve_test();
        #ifdef LOCAL
        cout << "_____________________" << endl;
        #endif
    }
    #ifdef LOCAL
    cerr << endl << "Elapsed time: " << 1. * clock() / CLOCKS_PER_SEC << '\n';
    #endif
    return 0;
}
