#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
// #define int long long

#ifdef FILE_WORK
    #include <fstream>
    ifstream in("build_project/input.txt");
    ofstream out("build_project/output.txt");
    #define cin in
    #define cout out
#endif

int gcd(int x, int y) {
	int temp = 0;
	while (y != 0) {
		temp = x%y;
		x = y;
		y = temp;
	}
	return x;
}

bool prime(int x) {
    if (x == 2) return true;
    else if (x%2 == 0) return false;
    for (int i = 3; i * i <= x; ++i) {
        if (x % i == 0) return false;
    }
    return true;
}

signed main() {
	int x, l, r; cin >> x >> l >> r;
    if (l == r) {
        int k = gcd(l, r);
        if (prime(k)) cout << k;
        return 0;
    }
	vector<bool> primes(r, true);
	vector<int> numbers;
	primes[0] = false;
	for (int i = 2; i < r; ++i) {
		if (!primes[i]) continue;
		if (1ll * i * i > 1ll * r) continue;
		for (int j = i * i; j < r; j += i) {
			primes[j] = false;
		}
	}
	

	for (int i = l; i <= r; ++i) {
		if (primes[gcd(x, i)])
			numbers.push_back(i);
	}
	sort(numbers.begin(), numbers.end());
	cout << numbers.size() << "\n";
	for (int x: numbers) cout << x << " ";
	return 0;
}