﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define int long long

const int inf = 2147483647;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

vector<int> pool, answer;

bool process(int x, int k, int last) {
    //cout << "? " << x << " " << k << " " << last << endl;
    if (x == 0 && k == 0) return true;
    if (x <= 0 || last >= pool.size()) return false;
    if (process(x, k, last + 1)) return true;
    answer.push_back(pool[last]);
    if (process(x - pool[last], k - 1, last + 1)) return true;
    answer.pop_back();
    return false;
}

void solve(int n, int k) {
    answer.clear();
    for (int i = 1; i * i < n; i++) pool.push_back(n - i * i);
    reverse(pool.begin(), pool.end());
    if (!process(n, k, 0)) {
        cout << "NO";
    }
    else {
        cout << "YES\n";
        for (int i : answer) {
            cout << i << " ";
        }
    }
}

signed main() {
    int n, k;
    cin >> n >> k;
    solve(n, k);
    /*
    for (int i = 1; i <= 100; i++) {
        cout << "\n\n---------- " << i << " 2\n";
        solve(i, 2);
    }
    */
}