from functools import lru_cache


def is_different_nums(x, y):
    if x == y:
        return False
    multipliers_of_x = multipliers_of(x)
    multipliers_of_y = multipliers_of(y)
    amount_of_same_multipliers = 0
    for mx in multipliers_of_x:
        if mx in multipliers_of_y:
            amount_of_same_multipliers += 1
        if amount_of_same_multipliers == 2:
            return False
    return True


@lru_cache
def multipliers_of(num: int):
    if num < 2:
        return [num]
    result = []
    for m in range(2, num+1):
        if num % m == 0:
            result.append(m)
    return result


if __name__ == "__main__":
    x = int(input())
    start_search = int(input())
    end_search = int(input())
    ys = list(filter(lambda n: is_different_nums(n, x), range(start_search, end_search + 1)))
    print(len(list(ys)))
    print(" ".join(map(str, ys)))
